<template>
   <b-container class="animated fadeIn" fluid>
       <b-card>
           <b-row>
               <b-col md="9">
               <h4 class="card-title">Danh sách đại lý </h4>
               </b-col>
               <b-col md="3">
                    <router-link to="/agency/create" tag="button" class="btn btn-success pull-right" v-if="$store.getters.isAdmin == 1">Tạo mới</router-link>
               </b-col>
              
           </b-row>
        <b-row>
            <b-col md="3" class="my-1 hidden-xs">
                <b-form-group horizontal label="Hiển thị">
                    <b-form-select :options="pageOptions" v-model="perPage" />
                </b-form-group>
            </b-col>
        <b-col md="9" class="my-1">
        <b-form-group horizontal label="Tìm kiếm" class="mb-0 pull-right">
          <b-input-group>
            <b-form-input v-model="filter" placeholder="Tìm kiếm" />
            <b-input-group-append>
              <b-btn :disabled="!filter" @click="filter = ''">Xóa</b-btn>
            </b-input-group-append>
          </b-input-group>
        </b-form-group>
      </b-col>
        </b-row>
      <b-table  hover responsive
               :items="agencies" 
               :fields="fields"
               :filter="filter"
               :current-page="currentPage"
               :per-page="perPage">
         
                     <template slot="actions" slot-scope="row">
        <!-- We use @click.stop here to prevent a 'row-clicked' event from also happening -->
       <b-button size="sm" @click.stop="showAddPaymentModal(row.item, row.index, $event.target)" class="mr-1" variant="primary">
          Thu tiền
        </b-button>
        <b-button size="sm" variant="success" :to="{ name: 'Cập nhật đại lý', params: { agencyId: row.item.id}}" v-if="$store.state.is_admin == 1">Cập nhật</b-button>
      </template>  
      </b-table>
          <b-row>
      <b-col md="6" class="my-1">
        <b-pagination :total-rows="totalRows" :per-page="perPage" v-model="currentPage" class="my-0" />
      </b-col>
    </b-row>
</b-card>
<add-payment-modal ref="paymentModal" :agency="selectedAgency"></add-payment-modal>
   </b-container>

</template>

<script>
import { alerts, Comma } from "@/utils";
import { event } from "@/utils";
import { http } from "@/services";
import AddPaymentModal from "../payments/AddPaymentModal";

export default {
  name: "agency-table",
  components: { AddPaymentModal },
  data() {
    return {
      fields: [
        {
          key: "id",
          label: "Mã ĐL",
          sortable: true
        },
        {
          key: "name",
          label: "Tên đại lý",
          sortable: true
        },
        {
          key: "owner.fullname",
          label: "Chủ đại lý",
          sortable: true,
          class: "hidden-xs"
        },
        {
          key: "province.name",
          label: "Tỉnh/Thành",
          sortable: true,
          class: "hidden-xs"
        },
        {
          key: "salesman.name",
          label: "Người phụ trách",
          sortable: true,
          class: "hidden-xs"
        },
        // {
        //     key: 'revenue',
        //     label: 'Tổng thu',
        //     sortable: true,
        //     formatter: (value) => {
        //         return this.comma(value)
        //     }
        // },
        {
          key: "actions",
          label: "Actions"
        }
      ],
      agencies: [],
      selectedAgency: {
        type: Object
      },
      filter: null,
      openAddPaymentModal: false,
      currentPage: 1,
      perPage: 20,
      totalRows: 0,
      pageOptions: [5, 10, 15, 20]
    };
  },
  created() {
    this.fetchAgencies();
  },
  methods: {
    fetchAgencies() {
      http.get("/agency", response => {
        this.agencies = response.data.data;
        this.totalRows = response.data.data.length;
      });
    },
    moment: function() {
      return moment();
    },
    showAddPaymentModal(item, index, button) {
      // console.log(item);
      this.selectedAgency = item;
      if (item.owner == null) {
        alerts.warning("Không có thông tin chủ đại lý");
      } else {
        this.$refs.paymentModal.showModal();
      }
      // event.emit('showmodal');
      // this.$emit('show-modal', item);
    }
  },
  computed: {}
};
</script>